#import "AppController.h"
#import "NSString+tsv.h"
#import "SimpleSource.h"

@implementation AppController

- (void)tabView:(NSTabView *)tabView didSelectTabViewItem:(NSTabViewItem *)tabViewItem
{
	// Make sure that there is a table attached to the initialFirstResponder of the tab view item.
	id currentTable = [[oTabView selectedTabViewItem] initialFirstResponder];

	//	NSLog(@"This table for %@ autoresizesAllColumnsToFit = %d", [tabViewItem label], [currentTable autoresizesAllColumnsToFit]);
	if (nil == currentTable) NSLog(@"WARNING -- nil initialFirstResponder for %@", [tabViewItem label]);
}

- (void)addCornerView
{
	// Center the "+" icon in the corner view as a subview of the background.
	NSRect cornerViewRect = [[oTableForCornerView cornerView] bounds];
	NSRect viewRect = [oCornerView bounds];
	NSPoint origin = NSMakePoint((NSWidth(cornerViewRect)-NSWidth(viewRect))/2.0, (NSHeight(cornerViewRect)-NSHeight(viewRect))/2.0);

	[oCornerView setFrameOrigin:origin];
	[[oTableForCornerView cornerView] addSubview:oCornerView];
}


- (void)awakeFromNib
{
	NSString *path = [[NSBundle mainBundle] pathForResource:@"software" ofType:@"tsv"];
	NSString *tsv = [NSString stringWithContentsOfFile:path];
	[oSoftwareArray addObjectsFromArray:[tsv arrayFromTSV]];

	path = [[NSBundle mainBundle] pathForResource:@"database" ofType:@"tsv"];
	tsv = [NSString stringWithContentsOfFile:path];
	[oPeopleArray addObjectsFromArray:[tsv arrayFromTSV]];
	
	// Initialize current tab view
	[self tabView:oTabView didSelectTabViewItem:[oTabView selectedTabViewItem]];

	[self addCornerView];
}


/*"	delete the selected rows.  "Clear" item in "Edit" menu connects to delete: method in first responder.  We have the data source actually do the deleting.
"*/

- (IBAction) delete:(id)sender
{
	// Get the NSTableView we want to delete from.  In this case, we determine the "current" table view by getting the tab view item's initialFirstResponder, which is set in the nib.
	id currentTable = [[oTabView selectedTabViewItem] initialFirstResponder];
	if ([[currentTable dataSource] respondsToSelector:@selector(deleteSelectedRowsInTableView:)])
	{
		[[currentTable dataSource] deleteSelectedRowsInTableView:currentTable];
	}
}



@end
